//
//  AppDelegate.m
//  XGPS170 Developers Kit.
//
//  Version 2.5.1
//  Licensed under the terms of the BSD License, as specified below.

/*
 Copyright (c) 2015 Dual Electronics Corp.
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 Redistributions of source code must strong the above copyright notice, this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 Neither the name of the Dual Electronics Corporation nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import "AppDelegate.h"
#import "Blackjack+LifeCycleMgr.h"
#import "BlackjackDataStructures.h"

@implementation AppDelegate

#pragma mark - Application lifecycle
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    
	// For the device view controller, create a new view controller with a nib
    self.iPadMainVC = [[iPadViewController alloc] initWithNibName:@"iPadView" bundle:[NSBundle mainBundle]];
    
    // complete launch by adding everything to the window
	[self.window addSubview:self.iPadMainVC.view];
    self.window.rootViewController = self.iPadMainVC;
    [self.window makeKeyAndVisible];
    
    // Connect to the XGPS170
	self.blackjack = [[Blackjack alloc] init];
    
    // set prefs for demo app data view
    self.useDForPosition = YES;
    self.useDMForPosition = NO;
    self.useDMSForPosition = NO;
    self.useKnots = YES;
    self.useMetricForAlt = NO;
    self.useMetricForSpeed = NO;
    
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    
    // NOTE: this method is called:
	//		- when a dialog box (like an alert view) opens.
	//		- by a double-tap on the home button to bring up the multitasking menu
	//		- when the iPod/iPad/iPhone goes to sleep (manually or after the timer runs out)
	//		- when app exits becuase the home button is tapped (once)
    
    [self.blackjack blackjack_applicationWillResignActive];

}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.

    // NOTE: this method is called:
	//		- another app takes forefront.
	//		- after applicationWillResignActive in response to the home button is tapped (once)

    [self.blackjack blackjack_applicationDidEnterBackground];
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    
    // NOTE: this method is called:
	//		- when an app icon is already running in the background, and the app icon is clicked to resume the app
    
    [self.blackjack blackjack_applicationWillEnterForeground];
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
 
    // NOTE: this method is called:
	//		- when an app first opens
	//		- when an app is running & the iPod/iPad/iPhone goes to sleep and is then reawoken, e.g. when the app is
	//		  running->iPod/iPad/iPhone goes to sleep (manually or by the timer)->iPod/iPad/iPhone is woken up & resumes the app
	//		- when the app is resumed from when the multi-tasking menu is opened (in the scenario where the
	//		  app was running, the multitasking menu opened by a double-tap of the home button, followed by a tap on the screen to
	//		  resume the app.)

    [self.blackjack blackjack_applicationDidBecomeActive];
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    
    [self.blackjack blackjack_applicationWillTerminate];
    
    // remove the observers before dealloc is called
	[[NSNotificationCenter defaultCenter] removeObserver:self];
}

@end
