//
//  Bar.h
//  3D adjustable bar
//  XGPS170 Developers Kit.
//
//  Version 2.5.1
//  Licensed under the terms of the BSD License, as specified below.

/*
 Copyright (c) 2015 Dual Electronics Corp.
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 Redistributions of source code must strong the above copyright notice, this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 Neither the name of the Dual Electronics Corporation nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <UIKit/UIKit.h>

@interface Bar : UIView

@property float width;
@property float height;
@property float percentToFill;
@property float shadowSize;
@property float lowLimit;
@property float highLimit;
@property float scaleValue;
@property int startX;
@property int startY;
@property int fontSize;
@property int idNum;
@property BOOL orientation;
@property BOOL useGradientFill;
@property BOOL emphasizeLeftLabel;
@property BOOL emphasizeRightLabel;

@property (nonatomic, strong) NSString *leftLabelText;
@property (nonatomic, strong) NSString *rightLabelText;

- (void)updateBar:(float)fillValue leftLabelText:(NSString *)leftText rightLabelText:(NSString *)rightText;

- (void)updateBar:(float)fillValue leftLabelText:(NSString *)leftText
                               leftLabelEmphasis:(BOOL)leftEmphasis
                                  rightLabelText:(NSString *)rightText
                              rightLabelEmphasis:(BOOL)rightEmphasis;


@end
