//
//  UIView+CommonDrawingFuncs.h
//  XGPS170 Developers Kit.
//
//  Version 2.5.1
//  Licensed under the terms of the BSD License, as specified below.

/*
 Copyright (c) 2015 Dual Electronics Corp. All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 Redistributions of source code must strong the above copyright notice, this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 Neither the name of the Dual Electronics Corporation nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <UIKit/UIKit.h>

@interface UIView (CommonDrawingFuncs)

void drawLinearGradient(CGContextRef context, CGRect rect, CGColorRef startColor, CGColorRef  endColor);

void drawGlossAndGradient(CGContextRef context, CGRect rect, CGColorRef startColor, CGColorRef endColor);

CGMutablePathRef createRoundedRectForRect(CGRect rect, CGFloat radius);

- (void)drawGradientCircle:(CGContextRef)context
              centerPointX:(float)centerX
              centerPointY:(float)centerY
                    radius:(float)radius
              initialColor:(CGColorRef)topColor
                 fadeColor:(CGColorRef)bottomColor;

- (void) drawCenteredCircle:(CGContextRef)context
			   centerPointX:(float)centerX
			   centerPointY:(float)centerY
					 radius:(int)radius
			 colorForStroke:(UIColor *)strokeColor
			   colorForFill:(UIColor *)fillColor;

- (void) drawCrosshairs:(CGContextRef)context
           centerPointX:(float)centerX
           centerPointY:(float)centerY
				   size:(int)size
		 colorForStroke:(UIColor *)strokeColor;

- (void) drawBoundingBox:(CGContextRef)context
				   inset:(float)insetDist
		  colorForStroke:(UIColor *)strokeColor
         axesStrokeWidth:(float)axesStrokeWidth;

- (void) drawRadarAxes:(CGContextRef)context
          centerPointX:(float)centerX
          centerPointY:(float)centerY
           radarRadius:(float)radarRadius
             tickScale:(float)tickScale
      reticleLineWidth:(float)lineWidth
        colorForStroke:(UIColor *)strokeColor;

- (void)drawLegendText:(CGContextRef)context text:(NSString *)displayText;

- (void) drawHemiCircle:(CGContextRef)context
           centerPointX:(float)centerX
           centerPointY:(float)centerY
                 radius:(int)radius
         colorForStroke:(UIColor *)strokeColor
           colorForFill:(UIColor *)fillColor;

- (void) drawCompassRose:(CGContextRef)context
            centerPointX:(float)centerX
            centerPointY:(float)centerY
                  radius:(float)radius
                   scale:(float)radiusScaleFactor
         angleOfRotation:(float)rotationAngle
                fontSize:(float)fontSize
         axesStrokeWidth:(float)axesStrokeWidth
          colorForStroke:(UIColor *)strokeColor
            colorForFill:(UIColor *)fillColor;

@end
