//
//  iPadViewController.h
//  XGPS170 Developers Kit.
//
//  Version 2.5.1
//  Licensed under the terms of the BSD License, as specified below.

/*
 Copyright (c) 2015 Dual Electronics Corp.
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 Redistributions of source code must strong the above copyright notice, this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 Neither the name of the Dual Electronics Corporation nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>
#import "WaitingToConnectView.h"
#import "Bar.h"
#import "Lightbulb.h"
#import "Blackjack/BlackjackDataStructures.h"

@interface iPadViewController : UIViewController <UIPopoverControllerDelegate, MKMapViewDelegate>

@property (weak, nonatomic) IBOutlet MKMapView *mapView;
@property (weak, nonatomic) IBOutlet UISwitch *notConMessageSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *nexradReceivedDataSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *conusReceivedDataSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *nexradTestDataSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *conusTestDataSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *outlineNexradRegionSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *outlineConusRegionSwitch;
@property (weak, nonatomic) IBOutlet UISwitch *trafficMessageSwitch;
@property (weak, nonatomic) IBOutlet UITextView *receivedMsgsTextView;
@property (weak, nonatomic) IBOutlet UISwitch *dataSourceSwitch;
@property (weak, nonatomic) IBOutlet UILabel *receivedRadioTierLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadNEXRADLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadCONUSLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadNOTAMLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadMETARLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadTAFLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadAIRMETLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadSIGMETLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadPIREPLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadWINDSLabel;
@property (weak, nonatomic) IBOutlet UILabel *lookaheadSUALabel;

- (IBAction)nexradReceivedDataSwitchChanged:(id)sender;
- (IBAction)conusReceivedDataSwitchChanged:(id)sender;
- (IBAction)nexradTestDataSwitchChanged:(id)sender;
- (IBAction)conusTestDataSwitchChanged:(id)sender;
- (IBAction)notConMsgSwitchChanged:(id)sender;
- (IBAction)outlineNexradRegionSwitchChanged:(id)sender;
- (IBAction)outlineConusRegionSwitchChanged:(id)sender;
- (IBAction)dataSourceSwitchChanged:(id)sender;
- (IBAction)settingsButtonTouched:(id)sender;

- (void)displayReceivedTextualProducts:(NSMutableDictionary *)dictionaryOfItems withType:(uint32_t)type;
- (void)displayShortTrafficReport:(ShortTrafficObjectInfo *)stoi;
- (void)displayBasicAndLongTrafficReport:(LongTrafficObjectInfo *)ltoi;

@end
